package com.ec.mutualistapichincha.listasnegras.dao;

import java.util.Date;
import java.util.List;

import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.persistence.TemporalType;

import com.ec.mutualistapichincha.base.util.Ctes;
import com.ec.mutualistapichincha.listasnegras.model.ClConsepValida;

@Stateless
public class ClConsepValidaDaoBean extends JPADao<Integer, ClConsepValida> {

	public List<String> listarModulos() {
		return em.createQuery(" select distinct(o.modulo) from ClConsepValida o where o.modulo != null ", String.class).getResultList();
	}

	@SuppressWarnings("unchecked")
	public List<ClConsepValida> listar(final ClConsepValida clConsep, final Date fechaI, final Date fechaF) {
		StringBuilder sql = new StringBuilder();
		StringBuilder sqlWhere = new StringBuilder();
		sql.append(" select o from ClConsepValida o ");
		String query = "";

		if (Ctes.stringNoNuloNoVacio(clConsep.getCedula())) {
			sqlWhere.append(" o.cedula = '");
			sqlWhere.append(clConsep.getCedula());
			sqlWhere.append("'  and ");
		}
		if (Ctes.stringNoNuloNoVacio(clConsep.getApellidos())) {
			sqlWhere.append(" o.apellidos = '");
			sqlWhere.append(clConsep.getApellidos());
			sqlWhere.append("'  and ");
		}
		if (Ctes.stringNoNuloNoVacio(clConsep.getNombres())) {
			sqlWhere.append(" o.nombres = '");
			sqlWhere.append(clConsep.getNombres());
			sqlWhere.append("'  and ");
		}
		if (Ctes.stringNoNuloNoVacio(clConsep.getAccion())) {
			sqlWhere.append(" o.accion = '");
			sqlWhere.append(clConsep.getAccion());
			sqlWhere.append("'  and ");
		}
		if (Ctes.stringNoNuloNoVacio(clConsep.getBase())) {
			sqlWhere.append(" o.base = '");
			sqlWhere.append(clConsep.getBase());
			sqlWhere.append("'  and ");
		}
		if (Ctes.stringNoNuloNoVacio(clConsep.getExiste())) {
			sqlWhere.append(" o.existe = '");
			sqlWhere.append(clConsep.getExiste());
			sqlWhere.append("'  and ");
		}
		if (Ctes.stringNoNuloNoVacio(clConsep.getModulo())) {
			sqlWhere.append(" o.modulo = '");
			sqlWhere.append(clConsep.getModulo());
			sqlWhere.append("'  and ");
		}

		if (fechaI != null && fechaF != null) {
			sqlWhere.append(" date(o.fecha) between :fechaI and :fechaF ");
			sqlWhere.append("   and ");

		}
		if (sqlWhere.toString().length() > 0) {
			sql.append(" where ");
			sql.append(sqlWhere.toString());
			query = sql.toString();
			query = query.substring(0, query.length() - 5);
		} else
			query = sql.toString();

		if (fechaF != null && fechaI != null) {
			return em.createQuery(query).setParameter("fechaI", fechaI, TemporalType.DATE)
					.setParameter("fechaF", fechaF, TemporalType.DATE).getResultList();
		} else
			return em.createQuery(query).getResultList();
	}

	@TransactionAttribute(TransactionAttributeType.REQUIRES_NEW)
	public void crearTransactionNew(final ClConsepValida entity) {
		em.persist(entity);
	}
}
