package com.ec.mutualistapichincha.listasnegras.dao;

import java.util.Date;
import java.util.List;

import javax.ejb.EJB;
import javax.ejb.Stateless;

import com.ec.mutualistapichincha.base.util.Ctes;
import com.ec.mutualistapichincha.listasnegras.model.ClConsepValida;
import com.ec.mutualistapichincha.listasnegras.model.ClNarcoLavado;
import com.ec.mutualistapichincha.listasnegras.model.ExcepcionesBasesNeg;
import com.ec.mutualistapichincha.listasnegras.util.MensajesValidacion;

@SuppressWarnings("unchecked")
@Stateless
public class ClNarcoLavadoDaoBean extends JPADao<Long, ClNarcoLavado> {

	@EJB
	private ClConsepValidaDaoBean clConsepValidaDaoBean;

	@EJB
	private ExcepcionesBasesNegDaoBean excepcionesBasesNegDaoBean;

	public List<ClNarcoLavado> buscarApell(final String apellido) {
		return em.createQuery(
				"select o from ClNarcoLavado o where lower(o.apellidos) like '%"
						+ apellido.trim().toLowerCase() + "%'").getResultList();
	}

	public ClNarcoLavado buscarCed(final String cedula) {

		List<ClNarcoLavado> list = em.createQuery(
				"select o from ClNarcoLavado o where o.cedula like '%"
						+ cedula.trim().toLowerCase() + "%'").getResultList();
		if (list.size() > 0)
			return list.get(0);
		else
			return null;

	}

	public boolean fichado(final String cedula, final String nombres) {
		return em
				.createQuery(
						"select o from ClNarcoLavado o where o.cedula='"
								+ cedula
								+ "' or (lower(concat(o.apellidos,' ',o.nombres))=lower('"
								+ nombres + "'))").getResultList().size() > 0;
	}

	public int narcoFichado(final String cedula, final String nombres) {

		List<ClNarcoLavado> ced = em.createQuery(
				"select o from ClNarcoLavado o where o.cedula like '"
						+ cedula.trim() + "'").getResultList();
		if (ced.size() > 0)
			return 1;

		String aux = "";
		String nombreAux = nombres;

		if (!"".equals(nombreAux)) {
			String n[] = nombreAux.split(" ");
			for (String string : n) {
				if (string.length() > 0) {
					aux += string;
					aux += " ";
				}
			}
		}

		aux = aux.trim();

		List<ClNarcoLavado> nom = em
				.createQuery(
						"select o from ClNarcoLavado o where concat(rtrim(o.apellidos),' ',rtrim(o.nombres))= '"
								+ aux.toUpperCase() + "'").getResultList();
		if (nom.size() > 0)
			return 2;
		else
			return 0;
	}

	public int narcoFichado(final String cedula, final String nombres,
			final String apellidos) {
		String sql = "select count(*) from ClNarcoLavado o where upper(rtrim(o.cedula)) = :cedula ";
		Number n = (Number) em.createQuery(sql)
				.setParameter("cedula", cedula.trim().toUpperCase())
				.getSingleResult();
		if (n.intValue() > 0)
			return 1;

		sql = "select count(*) from ClNarcoLavado o where upper(rtrim(o.apellidos)) like concat(:ape,'%') and upper(rtrim(o.nombres)) like concat(:nom,'%')";
		n = (Number) em.createQuery(sql)
				.setParameter("nom", nombres.trim().toUpperCase())
				.setParameter("ape", apellidos.trim().toUpperCase())
				.getSingleResult();
		if (n.intValue() > 0)
			return 2;
		else
			return 0;
	}

	public int narcoFichado(final String cedula, String nombres,
			String apellidos, final int operador, final String accion,
			final String modulo) {

		if (apellidos == null)
			apellidos = "";
		if (nombres == null)
			nombres = "";

		ExcepcionesBasesNeg base = excepcionesBasesNegDaoBean.buscarCedula(
				cedula, MensajesValidacion.BASECONSEPOFAC);
		if (base != null) {
			ClConsepValida consep = new ClConsepValida();
			consep.setCedula(cedula);
			consep.setApellidos(base.getApellidos());
			consep.setNombres(base.getNombres());
			consep.setBase("CONSEP");
			consep.setExiste("NO");
			consep.setFecha(new Date());
			consep.setOperador(operador);
			consep.setAccion(accion);
			consep.setModulo(modulo);
			consep.setCriterioExiste("EXCEPCIONADO");
			clConsepValidaDaoBean.crearTransactionNew(consep);
			return 0;
		}

		String sql = "select o from ClNarcoLavado o where upper(rtrim(o.cedula)) = :ced";
		List<ClNarcoLavado> n = em.createQuery(sql)
				.setParameter("ced", cedula.trim().toUpperCase())
				.getResultList();

		if (n.size() > 0) {
			ClConsepValida consep = new ClConsepValida();
			consep.setCedula(cedula);
			if (n.size() == 1) {
				ClNarcoLavado c = n.get(0);
				consep.setApellidos(c.getApellidos() != null ? c.getApellidos()
						.trim() : "");
				consep.setNombres(c.getNombres() != null ? c.getNombres()
						.trim() : "");
			} else {
				consep.setApellidos(apellidos);
				consep.setNombres(nombres);
			}
			consep.setBase("CONSEP");
			consep.setExiste("SI");
			consep.setFecha(new Date());
			consep.setOperador(operador);
			consep.setAccion(accion);
			consep.setModulo(modulo);
			consep.setCriterioExiste("IDENTIFICACION");
			clConsepValidaDaoBean.crearTransactionNew(consep);
			return 1;
		}

		if (!(Ctes.stringNoNuloNoVacio(apellidos) && Ctes
				.stringNoNuloNoVacio(nombres))) {
			ClConsepValida consep = new ClConsepValida();
			consep.setCedula(cedula);
			consep.setApellidos(apellidos);
			consep.setNombres(nombres);
			consep.setBase("CONSEP");
			consep.setExiste("NO");
			consep.setFecha(new Date());
			consep.setOperador(operador);
			consep.setAccion(accion);
			consep.setModulo(modulo);
			consep.setCriterioExiste("");
			clConsepValidaDaoBean.crearTransactionNew(consep);
			return 0;
		}

		sql = "select o from ClNarcoLavado o where upper(rtrim(o.apellidos)) like concat(:ape,'%') and upper(rtrim(o.nombres)) like concat(:nom,'%')";
		n = em.createQuery(sql)
				.setParameter("ape", apellidos.trim().toUpperCase())
				.setParameter("nom", nombres.trim().toUpperCase())
				.getResultList();

		if (n.size() > 0) {
			ClConsepValida consep = new ClConsepValida();
			consep.setApellidos(apellidos);
			consep.setNombres(nombres);
			if (n.size() == 1) {
				String c = n.get(0).getCedula();
				c = c == null ? "" : c.trim();
				consep.setCedula(c.equalsIgnoreCase("NE") ? cedula : c);
			} else {
				consep.setCedula(cedula);
			}
			consep.setBase("CONSEP");
			consep.setExiste("SI");
			consep.setFecha(new Date());
			consep.setOperador(operador);
			consep.setAccion(accion);
			consep.setModulo(modulo);
			consep.setCriterioExiste("APELLIDOS Y NOMBRES");
			clConsepValidaDaoBean.crearTransactionNew(consep);
			return 2;
		} else {
			ClConsepValida consep = new ClConsepValida();
			consep.setCedula(cedula);
			consep.setApellidos(apellidos);
			consep.setNombres(nombres);
			consep.setBase("CONSEP");
			consep.setExiste("NO");
			consep.setFecha(new Date());
			consep.setOperador(operador);
			consep.setAccion(accion);
			consep.setModulo(modulo);
			consep.setCriterioExiste("");
			clConsepValidaDaoBean.crearTransactionNew(consep);
			return 0;
		}
	}

	public List<ClNarcoLavado> listClNarco(final String cedula,
			final String nombre, final String apellido) {
		String sql = "select o from ClNarcoLavado o where o.cedula = '"
				+ cedula + "' or (o.apellidos like '" + apellido
				+ "%' and o.nombres like '%" + nombre + "%')";
		return em.createQuery(sql).getResultList();
	}
}
