package com.ec.mutualistapichincha.listasnegras.dao;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

import com.ec.mutualistapichincha.listasnegras.model.EntidadBase;


public interface Dao<K extends Serializable, E extends EntidadBase> {

	E crear(E entity);

	E actualizar(E entity);

	void eliminar(E entity);

	void eliminar(K id);

	E buscarPorId(K id);

	List<E> buscarTodo();

	List<E> buscarTodo(String... orderFields);

	<O extends Object> List<E> executeQuery(String ejbql, Map<String, O> parameterValues);

	void immediateCommit();

	void desconectar(E entity);
}