package com.ec.mutualistapichincha.listasnegras.dao;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.ejb.EJB;
import javax.ejb.Stateless;

import com.ec.mutualistapichincha.listasnegras.model.ClConsepValida;
import com.ec.mutualistapichincha.listasnegras.model.ExcepcionesBasesNeg;
import com.ec.mutualistapichincha.listasnegras.model.Ofac;
import com.ec.mutualistapichincha.listasnegras.util.MensajesValidacion;


@SuppressWarnings("unchecked")
@Stateless
public class OfacDaoBean extends JPADao<Integer, Ofac> {

	@EJB
	private ClConsepValidaDaoBean servClConsep;

	@EJB
	private ExcepcionesBasesNegDaoBean servExcep;

	/***
	 * 
	 * @param nombre
	 * @param apellido
	 * @param cedula
	 * @return 0 No se encuentra registrado, 1 encontrado por cedula, 2
	 *         encontrado por Nombre Apellido
	 */
	public int listaOfacNomb(final String cedula, String nombres,
			String apellidos, final Integer operador, final String accion,
			final String modulo) {

		if (apellidos == null)
			apellidos = "";
		if (nombres == null)
			nombres = "";

		ExcepcionesBasesNeg base = servExcep.buscarCedula(cedula,
				MensajesValidacion.BASECONSEPOFAC);
		if (base != null) {
			ClConsepValida consep = new ClConsepValida();
			consep.setCedula(cedula);
			consep.setApellidos(base.getApellidos());
			consep.setNombres(base.getNombres());
			consep.setBase("OFAC");
			consep.setExiste("NO");
			consep.setFecha(new Date());
			consep.setOperador(operador);
			consep.setAccion(accion);
			consep.setModulo(modulo);
			consep.setCriterioExiste("EXCEPCIONADO");
			servClConsep.crearTransactionNew(consep);
			return 0;
		}

		apellidos = apellidos.trim();
		nombres = nombres.trim();

		String nom = "";
		if (nombres.equalsIgnoreCase(""))
			nom = apellidos;
		else
			nom = apellidos + ", " + nombres;

		nom = nom.trim();
		String sql = "";

		sql = "select count(*) from Ofac ofac where lower(substr(ofac.descripcion,1,4000)) like concat('%',:ced,'%')";
		Number listCI = (Number) em.createQuery(sql)
				.setParameter("ced", cedula.trim().toLowerCase())
				.getSingleResult();
		if (listCI != null) {
			if (listCI.intValue() > 0) {
				ClConsepValida consep = new ClConsepValida();
				consep.setCedula(cedula);
				consep.setApellidos(apellidos);
				consep.setNombres(nombres);
				consep.setBase("OFAC");
				consep.setExiste("SI");
				consep.setFecha(new Date());
				consep.setOperador(operador);
				consep.setAccion(accion);
				consep.setModulo(modulo);
				consep.setCriterioExiste("IDENTIFICACION");
				servClConsep.crearTransactionNew(consep);
				return 1;
			}
		}

		/*
		 * String []aux = nom.split(" "); List<String> busq = new
		 * ArrayList<String>(); for (String string : aux) {
		 * if(string.length()>0) busq.add(string);
		 * 
		 * } if(busq.size()==0){ ClConsepValida consep = new ClConsepValida();
		 * consep.setCedula(cedula); consep.setApellidos(apellidos);
		 * consep.setNombres(nombres); consep.setBase("OFAC");
		 * consep.setExiste("NO"); consep.setFecha(new Date());
		 * consep.setOperador(operador); consep.setAccion(accion);
		 * consep.setModulo(modulo); consep.setCriterioExiste("");
		 * servClConsep.crearTransactionNew(consep); return 0; }
		 */

		if (nom.equalsIgnoreCase("") || nom.equalsIgnoreCase(",")) {
			ClConsepValida consep = new ClConsepValida();
			consep.setCedula(cedula);
			consep.setApellidos(apellidos);
			consep.setNombres(nombres);
			consep.setBase("OFAC");
			consep.setExiste("NO");
			consep.setFecha(new Date());
			consep.setOperador(operador);
			consep.setAccion(accion);
			consep.setModulo(modulo);
			consep.setCriterioExiste("");
			servClConsep.crearTransactionNew(consep);
			return 0;
		}

		StringBuilder sql2 = new StringBuilder();

		/*
		 * if(busq.size()>=1) sql2.append(
		 * "select count(*) from Ofac ofac where lower(substr(ofac.descripcion,1,4000)) like (concat('%',concat('"
		 * ) .append(busq.get(0).toLowerCase()) .append("','%')))");
		 * if(busq.size()>=2) sql2.append(
		 * " and lower(substr(ofac.descripcion,1,4000)) like (concat('%',concat('"
		 * ) .append(busq.get(1).toLowerCase()) .append("','%')))") ;
		 * if(busq.size()>=3) sql2.append(
		 * " and lower(substr(ofac.descripcion,1,4000)) like (concat('%',concat('"
		 * ) .append(busq.get(2).toLowerCase()) .append("','%')))");
		 * if(busq.size()>=4) sql2.append(
		 * " and lower(substr(ofac.descripcion,1,4000)) like (concat('%',concat('"
		 * ) .append(busq.get(3).toLowerCase()) .append("','%')))");
		 */

		sql2.append(
				"select count(*) from Ofac ofac where lower(substr(ofac.descripcion,1,4000)) like (concat('%',concat('")
				.append(nom.toLowerCase()).append("','%')))");

		Number list = (Number) em.createQuery(sql2.toString())
				.getSingleResult();
		if (list != null) {
			if (list.intValue() > 0) {
				ClConsepValida consep = new ClConsepValida();
				consep.setCedula(cedula);
				consep.setApellidos(apellidos);
				consep.setNombres(nombres);
				consep.setBase("OFAC");
				consep.setExiste("SI");
				consep.setFecha(new Date());
				consep.setOperador(operador);
				consep.setAccion(accion);
				consep.setModulo(modulo);
				consep.setCriterioExiste("APELLIDOS Y NOMBRES");
				servClConsep.crearTransactionNew(consep);
				return 2;
			} else {
				ClConsepValida consep = new ClConsepValida();
				consep.setCedula(cedula);
				consep.setApellidos(apellidos);
				consep.setNombres(nombres);
				consep.setBase("OFAC");
				consep.setExiste("NO");
				consep.setFecha(new Date());
				consep.setOperador(operador);
				consep.setAccion(accion);
				consep.setModulo(modulo);
				consep.setCriterioExiste("");
				servClConsep.crearTransactionNew(consep);
				return 0;
			}
		} else {
			ClConsepValida consep = new ClConsepValida();
			consep.setCedula(cedula);
			consep.setApellidos(apellidos);
			consep.setNombres(nombres);
			consep.setBase("OFAC");
			consep.setExiste("NO");
			consep.setFecha(new Date());
			consep.setOperador(operador);
			consep.setAccion(accion);
			consep.setModulo(modulo);
			consep.setCriterioExiste("");
			servClConsep.crearTransactionNew(consep);
			return 0;
		}

	}

	/***
	 * 
	 * @param nombre
	 *            = apellido +", "+ nombre
	 * @param cedula
	 * @return 0 No se encuentra registrado, 1 encontrado por cedula, 2
	 *         encontrado por Nombre Apellido
	 */
	public int listaOfacNomb(String nombre, final String cedula) {

		String nom = nombre;
		nom = nom.trim();
		String sql = "";

		sql = "select count(*) from Ofac ofac where lower(substr(ofac.descripcion,1,4000)) like concat('%',:ced,'%')";
		Number listCI = (Number) em.createQuery(sql)
				.setParameter("ced", cedula.trim().toLowerCase())
				.getSingleResult();
		if (listCI != null) {
			if (listCI.intValue() > 0)
				return 1;
		}

		/*
		 * String []aux = nom.split(" "); List<String> busq = new
		 * ArrayList<String>(); for (String string : aux) {
		 * if(string.length()>0) busq.add(string);
		 * 
		 * }
		 * 
		 * if(busq.size()==0) return 0;
		 */

		StringBuilder sql2 = new StringBuilder();

		/*
		 * if(busq.size()>=1) sql2.append(
		 * "select count(*) from Ofac ofac where lower(substr(ofac.descripcion,1,4000)) like concat('%','"
		 * ) .append(busq.get(0).toLowerCase()) .append("','%')");
		 * if(busq.size()>=2) sql2.append(
		 * " and lower(substr(ofac.descripcion,1,4000)) like concat('%','")
		 * .append(busq.get(1).toLowerCase()) .append("','%')");
		 * if(busq.size()>=3) sql2.append(
		 * " and lower(substr(ofac.descripcion,1,4000)) like concat('%','")
		 * .append(busq.get(2).toLowerCase()) .append("','%')");
		 * if(busq.size()>=4) sql2.append(
		 * " and lower(substr(ofac.descripcion,1,4000)) like concat('%','")
		 * .append(busq.get(3).toLowerCase()) .append("','%')");
		 */

		if (nombre != null)
			nombre = nombre.trim();

		if (nombre.equalsIgnoreCase("") || nombre.equalsIgnoreCase(","))
			return 0;

		sql2.append(
				"select count(*) from Ofac ofac where lower(substr(ofac.descripcion,1,4000)) like concat('%','")
				.append(nombre.toLowerCase()).append("','%')");

		Number list = (Number) em.createQuery(sql2.toString())
				.getSingleResult();
		if (list != null) {
			if (list.intValue() > 0)
				return 2;
			else
				return 0;
		} else
			return 0;

	}

	/****
	 * 
	 * @param nombre
	 *            concatenar apellidos + nombre con un espcacio
	 * @return
	 */
	public List<Ofac> listaOfac(final String nombre) {

		List<Ofac> list = new ArrayList<Ofac>();
		List<Ofac> ret = new ArrayList<Ofac>();

		String nom = nombre;
		nom = nom.trim();

		String[] aux = nom.split(" ");
		List<String> busq = new ArrayList<String>();
		for (String string : aux) {
			if (string.length() > 0)
				busq.add(string);
		}

		StringBuilder sql = new StringBuilder();

		/*
		 * if(busq.size()>=1) sql.append(
		 * "select ofac from Ofac ofac where lower(substr(ofac.descripcion,1,4000)) like lower(concat('%',concat('"
		 * +busq.get(0)+"','%')))"); if(busq.size()>=2) sql.append(
		 * " and lower(substr(ofac.descripcion,1,4000)) like lower(concat('%',concat('"
		 * +busq.get(1)+"','%')))") ; if(busq.size()>=3) sql.append(
		 * " and lower(substr(ofac.descripcion,1,4000)) like lower(concat('%',concat('"
		 * +busq.get(2)+"','%')))"); if(busq.size()>=4) sql.append(
		 * " and lower(substr(ofac.descripcion,1,4000)) like lower(concat('%',concat('"
		 * +busq.get(3)+"','%')))");
		 */

		if (busq.size() >= 1)
			sql.append(
					" from Ofac ofac where lower(substr(ofac.descripcion,1,4000)) like concat('%','")
					.append(busq.get(0).toLowerCase()).append("','%')");
		if (busq.size() >= 2)
			sql.append(
					" and lower(substr(ofac.descripcion,1,4000)) like concat('%','")
					.append(busq.get(1).toLowerCase()).append("','%')");
		if (busq.size() >= 3)
			sql.append(
					" and lower(substr(ofac.descripcion,1,4000)) like concat('%','")
					.append(busq.get(2).toLowerCase()).append("','%')");
		if (busq.size() >= 4)
			sql.append(
					" and lower(substr(ofac.descripcion,1,4000)) like concat('%','")
					.append(busq.get(3).toLowerCase()).append("','%')");

		list = em.createQuery(sql.toString()).getResultList();
		ret = cargarList(list);
		return ret;
	}

	public List<Ofac> cargarList(final List<Ofac> list) {

		List<Ofac> ret = new ArrayList<Ofac>();
		// String subCad="";
		StringBuilder scad = new StringBuilder();
		for (Ofac ofac : list) {
			String cad = ofac.getDescripcion();

			for (int i = 0; i < cad.length(); i++) {
				char c = cad.charAt(i);
				if (";".equals(c + "")) {
					// subCad+= ";"+"\r";
					scad.append(";");
					scad.append("\r");
				} else {
					// subCad +=c+"";
					scad.append(c);
				}
			}

			Ofac of = new Ofac();
			of.setCodigo(ofac.getCodigo());
			// of.setDescripcion(subCad);
			of.setDescripcion(scad.toString());
			scad.delete(0, scad.length());
			ret.add(of);
		}

		return ret;
	}

}
