package com.ec.mutualistapichincha.listasnegras.model;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.envers.RevisionEntity;
import org.hibernate.envers.RevisionNumber;
import org.hibernate.envers.RevisionTimestamp;

import com.ec.mutualistapichincha.base.model.ConstantesAuditoria;

@Entity
@Table(name = "AUDITORIA_REV_ENTITY", schema = ConstantesAuditoria.SCHEMA)
@RevisionEntity(AuditoriaRevEntityListener.class)
public class AuditoriaRevEntity implements Serializable {
	/**
	 *
	 */
	private static final long serialVersionUID = 5784537406864905182L;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@RevisionNumber
	private int id;

	@RevisionTimestamp
	private long timestamp;

	@Column(name = "username", length = 32)
	private String username;

	@Column(name = "fecha_evento")
	@Temporal(TemporalType.TIMESTAMP)
	private Date fechaEvento;

	@Column(name = "direccion_ip")
	private String ip;

	@Column(name = "terminal")
	private String terminal;

	@Column(name = "agencia")
	private String agencia;

	public int getId() {
		return id;
	}

	public void setId(final int id) {
		this.id = id;
	}

	public long getTimestamp() {
		return timestamp;
	}

	public void setTimestamp(final long timestamp) {
		this.timestamp = timestamp;
	}

	public String getUsername() {
		return username;
	}

	public void setUsername(final String username) {
		this.username = username;
	}

	public Date getFechaEvento() {
		return fechaEvento;
	}

	public void setFechaEvento(final Date fechaEvento) {
		this.fechaEvento = fechaEvento;
	}

	public String getIp() {
		return ip;
	}

	public void setIp(final String ip) {
		this.ip = ip;
	}

	public String getTerminal() {
		return terminal;
	}

	public void setTerminal(final String terminal) {
		this.terminal = terminal;
	}

	public String getAgencia() {
		return agencia;
	}

	public void setAgencia(final String agencia) {
		this.agencia = agencia;
	}
}
