package com.ec.mutualistapichincha.listasnegras.model;

import java.util.Date;

import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.hibernate.envers.RevisionListener;

import com.ec.mutualistapichincha.listasnegras.audit.DatosAuditoria;
import com.ec.mutualistapichincha.listasnegras.service.ServicioDatosAuditoria;

public class AuditoriaRevEntityListener implements RevisionListener {

	@Override
	public void newRevision(final Object revisionEntity) {
		AuditoriaRevEntity revEntity = (AuditoriaRevEntity) revisionEntity;
		revEntity.setFechaEvento(new Date());

		DatosAuditoria datosAuditoria = obtenerDatosAuditoria();
		revEntity.setUsername(datosAuditoria.getUsuario().toString());
		revEntity.setTerminal(datosAuditoria.getTerminal());
		revEntity.setIp(datosAuditoria.getIpPublica());
		revEntity.setAgencia(datosAuditoria.getAgencia());

	}

	private DatosAuditoria obtenerDatosAuditoria() {
		try {
			InitialContext ctx = new InitialContext();
			ServicioDatosAuditoria servicio = (ServicioDatosAuditoria) ctx
					.lookup("java:global/mupi-listasnegras-ear/mupi-listasnegras-ejb/ServicioDatosAuditoria!com.ec.mutualistapichincha.listasnegras.service.ServicioDatosAuditoria");
			return servicio.obtenerDatosAuditoria();
		} catch (NamingException e) {
			e.printStackTrace();
			throw new RuntimeException("No se pudo obtener datos de auditoria para envers: " + e.getMessage() + " : " + e.getExplanation());
		}
	}
}
