package com.ec.mutualistapichincha.listasnegras.model;

// Generated 21/05/2013 03:41:30 PM by Hibernate Tools 3.2.4.GA

import java.math.BigDecimal;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.PrePersist;
import javax.persistence.PreUpdate;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.envers.AuditTable;
import org.hibernate.envers.Audited;
import org.hibernate.validator.constraints.Length;

/**
 * ClPeps generated by hbm2java
 */
@Entity
@Table(name = "CL_PEPS")
@Audited
@AuditTable(value = "AUT_CL_PEPS", schema = ConstantesAuditoria.SCHEMA)
public class ClPeps extends EntidadBase {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	private int id;
	private String nombres;
	private String cedula;
	private String cargo;
	private String empresa;
	private BigDecimal sueldo;
	private Date fecha;
	private String fuente;
	private String conyugue;
	private String cedulaConyugue;
	private String observaciones;
	private String estado;
	private Date fechaCrea;
	private Integer operador;
	private String terminal;
	private String agencia;

	public ClPeps() {
	}

	public ClPeps(final int id) {
		this.id = id;
	}

	public ClPeps(final int id, final String nombres, final String cedula, final String cargo, final String empresa,
			final BigDecimal sueldo, final Date fecha, final String fuente, final String conyugue, final Date fechaCrea) {
		this.id = id;
		this.nombres = nombres;
		this.cedula = cedula;
		this.cargo = cargo;
		this.empresa = empresa;
		this.sueldo = sueldo;
		this.fecha = fecha;
		this.fuente = fuente;
		this.conyugue = conyugue;
		this.fechaCrea = fechaCrea;
	}

	@PrePersist
	@PreUpdate
	private void preInsercion() {
		if (getCedula() != null)
			if (getCedula().length() > 15)
				setCedula(getCedula().substring(0, 15));

		if (getNombres() != null)
			if (getNombres().length() > 200)
				setNombres(getNombres().substring(0, 200));

		if (getCargo() != null)
			if (getCargo().length() > 200)
				setCargo(getCargo().substring(0, 200));

		if (getEmpresa() != null)
			if (getEmpresa().length() > 200)
				setEmpresa(getEmpresa().substring(0, 200));

		if (getFuente() != null)
			if (getFuente().length() > 500)
				setFuente(getFuente().substring(0, 500));

		if (getObservaciones() != null)
			if (getObservaciones().length() > 300)
				setObservaciones(getObservaciones().substring(0, 300));

		if (getConyugue() != null)
			if (getConyugue().length() > 200)
				setConyugue(getConyugue().substring(0, 200));

		if (getCedulaConyugue() != null)
			if (getCedulaConyugue().length() > 15)
				setCedulaConyugue(getCedulaConyugue().substring(0, 15));
	}

	@SuppressWarnings("unchecked")
	@Override
	@Id
	@Column(name = "ID", unique = true, nullable = false)
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	public Integer getId() {
		return this.id;
	}

	public void setId(final Integer id) {
		this.id = id;
	}

	@Column(name = "NOMBRES", length = 200)
	@Length(max = 200)
	public String getNombres() {
		return this.nombres;
	}

	public void setNombres(final String nombres) {
		this.nombres = nombres;
	}

	@Column(name = "CEDULA", length = 15)
	@Length(max = 15)
	public String getCedula() {
		return this.cedula;
	}

	public void setCedula(final String cedula) {
		this.cedula = cedula;
	}

	@Column(name = "CARGO", length = 200)
	@Length(max = 200)
	public String getCargo() {
		return this.cargo;
	}

	public void setCargo(final String cargo) {
		this.cargo = cargo;
	}

	@Column(name = "EMPRESA", length = 200)
	@Length(max = 200)
	public String getEmpresa() {
		return this.empresa;
	}

	public void setEmpresa(final String empresa) {
		this.empresa = empresa;
	}

	@Column(name = "SUELDO", precision = 15, scale = 0, columnDefinition = "decimal")
	public BigDecimal getSueldo() {
		return this.sueldo;
	}

	public void setSueldo(final BigDecimal sueldo) {
		this.sueldo = sueldo;
	}

	@Temporal(TemporalType.DATE)
	@Column(name = "FECHA", length = 10)
	public Date getFecha() {
		return this.fecha;
	}

	public void setFecha(final Date fecha) {
		this.fecha = fecha;
	}

	@Column(name = "FUENTE", length = 500)
	@Length(max = 500)
	public String getFuente() {
		return this.fuente;
	}

	public void setFuente(final String fuente) {
		this.fuente = fuente;
	}

	@Column(name = "CONYUGUE", length = 200)
	@Length(max = 200)
	public String getConyugue() {
		return this.conyugue;
	}

	public void setConyugue(final String conyugue) {
		this.conyugue = conyugue;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "FECHA_CREA", length = 26)
	public Date getFechaCrea() {
		return this.fechaCrea;
	}

	public void setFechaCrea(final Date fechaCrea) {
		this.fechaCrea = fechaCrea;
	}

	@Column(name = "OPERADOR")
	public Integer getOperador() {
		return operador;
	}

	public void setOperador(final Integer operador) {
		this.operador = operador;
	}

	@Column(name = "TERMINAL", length = 8)
	@Length(max = 8)
	public String getTerminal() {
		return terminal;
	}

	public void setTerminal(final String terminal) {
		this.terminal = terminal;
	}

	@Column(name = "AGENCIA", length = 2)
	@Length(max = 2)
	public String getAgencia() {
		return agencia;
	}

	public void setAgencia(final String agencia) {
		this.agencia = agencia;
	}

	@Column(name = "CEDULA_CONYUGUE", length = 15)
	public String getCedulaConyugue() {
		return cedulaConyugue;
	}

	public void setCedulaConyugue(final String cedulaConyugue) {
		this.cedulaConyugue = cedulaConyugue;
	}

	@Column(name = "OBSERVACIONES", length = 300)
	public String getObservaciones() {
		return observaciones;
	}

	public void setObservaciones(final String observaciones) {
		this.observaciones = observaciones;
	}

	@Column(name = "ESTADO", length = 1)
	public String getEstado() {
		return estado;
	}

	public void setEstado(final String estado) {
		this.estado = estado;
	}

}