package com.ec.mutualistapichincha.listasnegras.process;

import java.util.List;
import java.util.Map;

import com.ec.mutualistapichincha.listasnegras.enumerations.ParametrosIngresoExcepcion;
import com.ec.mutualistapichincha.listasnegras.exception.ProcessException;
import com.ec.mutualistapichincha.listasnegras.model.Tarea;

public interface GestorProcesos {

	Number iniciarProcesoIngresoExcepcion(Map<ParametrosIngresoExcepcion, String> parametros) throws ProcessException;

	List<Tarea> buscarTareas(String usuario) throws ProcessException;

	void reclamarTarea(Number idTarea, String usuario, boolean iniciar) throws ProcessException;

	void iniciarTarea(Number idTarea, final String usuario) throws ProcessException;

	Map<?, ?> obtenerVariablesTarea(Number idTarea) throws ProcessException;

	void completarTarea(Tarea tarea, String usuario) throws ProcessException;

	void abortarProceso(final Number idInstanciaProceso) throws ProcessException;
}