package com.ec.mutualistapichincha.test;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.List;
import java.util.Map;

import org.jbpm.services.task.utils.ContentMarshallerHelper;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;
import org.kie.api.runtime.KieSession;
import org.kie.api.runtime.manager.RuntimeEngine;
import org.kie.api.runtime.process.ProcessInstance;
import org.kie.api.task.TaskService;
import org.kie.api.task.model.Content;
import org.kie.api.task.model.Status;
import org.kie.api.task.model.Task;
import org.kie.api.task.model.TaskData;
import org.kie.api.task.model.TaskSummary;
import org.kie.services.client.api.RemoteRestRuntimeFactory;

public class TasksTest {

	private RuntimeEngine engine;

	private KieSession kieSession;

	private static final String PROCESS_ID = "ListasNegras.ExcepcionListasNegras";

	private URL baseUrl = null;

	@Before
	public void init() throws Exception {
		try {
			if (engine == null) {
				baseUrl = new URL(
						"http://172.25.212.100:8080/business-central/");
				RemoteRestRuntimeFactory factory = new RemoteRestRuntimeFactory(
						"com.ec.mutualistapichincha:bpm-listas-negras:1.0.0",
						baseUrl, "1283", "123abc!!");
				engine = factory.newRuntimeEngine();
				kieSession = engine.getKieSession();
			}
		} catch (MalformedURLException e) {
			throw new Exception(e);
		}
	}

	@Test
	@Ignore
	public void searchTasks() throws Exception {
		TaskService service = engine.getTaskService();
		List<TaskSummary> tasks = service.getTasksAssignedAsPotentialOwner(
				"1283", "en-UK");
		Assert.assertTrue(tasks.size() > 0);

	}

	@Test
	public void getTaskDetails() {
		try {
			TaskService service = engine.getTaskService();
			List<TaskSummary> tasks = service.getTasksAssignedAsPotentialOwner(
					"1283", "en-UK");
			long taskId = -1;
			for (TaskSummary summary : tasks) {
				if (summary.getStatus().equals(Status.InProgress)) {
					taskId = summary.getId();
				}
			}

			if (taskId > 0) {
				Task task = service.getTaskById(taskId);
				System.out.println(">>> task " + task.getId());
				TaskData taskData = task.getTaskData();
				Assert.assertNotNull(taskData);
				Long documentContentId = taskData.getDocumentContentId();
				Content content = service.getContentById(documentContentId);

				Map<?, ?> variableMap = ((Map<?, ?>) ContentMarshallerHelper
						.unmarshall(content.getContent(), null));
				Assert.assertFalse(variableMap.isEmpty());
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@Test
	@Ignore
	public void getProcessVariables() {
		ProcessInstance instance = engine.getKieSession().getProcessInstance(
				610);
		System.out.println(instance);
	}
}