package com.ec.mutualistapichincha.listasnegras.controller;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;

import com.ec.mutualistapichincha.listasnegras.exception.ProcessException;
import com.ec.mutualistapichincha.listasnegras.model.Tarea;
import com.ec.mutualistapichincha.listasnegras.process.GestorProcesos;
import com.ec.mutualistapichincha.security.MupiPrincipal;

@SuppressWarnings("serial")
public class BaseController implements Serializable {

	protected void agregarMensajeError(final String mensaje, final String detalle) {
		FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_ERROR, mensaje, detalle));
	}

	protected void agregarMensajeInfo(final String mensaje, final String detalle) {
		FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, mensaje, detalle));
	}

	protected void agregarMensajeAdvertencia(final String mensaje, final String detalle) {
		FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_WARN, mensaje, detalle));
	}

	protected MupiPrincipal getPrincipal() {
		return (MupiPrincipal) FacesContext.getCurrentInstance().getExternalContext().getUserPrincipal();
	}

	public boolean isExistenMensajes() {
		return FacesContext.getCurrentInstance().getMaximumSeverity() != null;
	}

	protected Object obtenerParametro(final String parametro) {
		return FacesContext.getCurrentInstance().getExternalContext().getRequestParameterMap().get(parametro);
	}

	protected void cargarVariablesTarea(final Tarea tarea, final GestorProcesos gestorProcesos) throws ProcessException {
		if (tarea != null) {
			if (tarea.getVariables() == null) {
				tarea.setVariables(new HashMap<String, String>());
			}
			Map<?, ?> variables = gestorProcesos.obtenerVariablesTarea(tarea.getIdTarea());
			for (Entry<?, ?> variable : variables.entrySet()) {
				tarea.getVariables().put(variable.getKey().toString(), variable.getValue().toString());
			}
		}
	}
}
